###################################################################################
#
# UserCheck 1.1b TCL
#
#This tcl on a timer will check if the users who have access @ X (chanserv)
#are on the channel where the tcl is activated
#
#If not there are 2 ways to action :
#
#1) x suspend + message on chan ( that contains the users that are not on chan )
#2) message on chan ( that contains the users that are not on chan )
#
#Version 1.1
#
#Added some commands
#
#!usercheck -list (will list the users that were found outside the chan)
#!usercheck -clear (era the list of users)
#
#!usercheck -except add <user> (add an except. This user will not be checked)
#		    list (list the except users)					
#		    del <user> (erase a user from exception list)					
#
#Added a module that if a user is found outside the chan the bot saves
#the time when he was found. Onjoin the user will be messaged with the
#time that he was spotted outside the chan.
#
#For the users who are spotted outside the chan and do not join for 
#<N> days  the bot will remuser them.
#
#Version 1.1b
#
#Solved a little issue about deleting data in the checking of expired entrys.
#
#Activate : .chanset #canal +usercheck | .set +usercheck
#
#						BLaCkShaDoW ProductionS
######################################################################################

#Set here the check time ( minutes )

set userc(time) "60"


#Set here the flags that are needed to check the usercheck list ( the except list)

set userc(flags) "mn|MN"


#Set here the number of days that the bot will keep the record of a user.
#If it past the user will be erased + remuser.

set userc(days) "30"


#Set here the action method ( 1 - suspend + channel message ; 0 - channel message )

set userc(method) "0"


#Set here the level of suspesion ( if a user is spotted logged and outside the chan)

set userc(slevel) "400"

#Set here the number of days for the suspend

set userc(sdays) "3d"


##########################################################
#
#			The End
#
##########################################################

setudef flag usercheck

set user_file "usercheck"
set excepts_file "usercheck.excepts"

if {![file exists $excepts_file]} {
	set file [open $excepts_file w]
	close $file
}

if {![file exists $user_file]} {
	set file [open $user_file w]
	close $file
}



bind pub $userc(flags) !usercheck usercheck:cmd
bind join - * usercheck:join

if {![info exists xstatus:timer_running]} {
timer $userc(time) xstatus:timer
set xstatus:timer_running 1
}


proc xstatus:timer:again {} {

xstatus:timer

}


proc xstatus:timer {} {
global userc

	set xmask "*!*@undernet.org"

	
if {[isignore "$xmask"]} {

	killignore $xmask

}

if {![info exists userc(channels_i)]} {
	
	set userc(channels_i) 0

}

if {![info exists userc(channels)]} {
foreach chan [channels] {
if {[channel get $chan usercheck]} {

	lappend userc(channels) [join $chan]

		}
	}
}



if {[info exists userc(channels)]} {

	set channel [lindex $userc(channels) $userc(channels_i)]
	
if {[validchan $channel]} {

	putserv "PRIVMSG X :status $channel"
	set ::xchan $channel
	
	bind notc - * xstatus:check:timer
	utimer 30 [list user:expire:check $channel]
	
}

} else {

timer $userc(time) xstatus:timer
return 1

}

 

incr userc(channels_i) +1

if {[lindex $userc(channels) $userc(channels_i)] != ""} {

utimer 15 [list xstatus:timer:again]

	} else {
	
if {[info exists userc(channels_i)]} {

	unset userc(channels_i)

}

if {[info exists userc(channels)]} {

	unset userc(channels)

}

timer $userc(time) xstatus:timer
return 1

	}
}


proc xstatus:check:timer {nick host hand text {dest ""}} {
	global userc user_file excepts_file
	
	set chans $::xchan
	set xmask "*!*@undernet.org"

if {$nick != "X"} { return 0 }

if {[isignore "$xmask"]} {

	killignore $xmask

}

if {[string match -nocase "*Auth:*" $text]} {
foreach word [split $text] {
	set word [filter $word]
	set username [join [scan $word %\[^/\]]]
	set nickname [join [scan $word %*\[^/\]/%s]]

if {($nickname != "") && ($username != "")} {

if {![onchan $nickname $chans]} {

	set file [open $excepts_file "r"]
	set database [read -nonewline $file]
	close $file
	set data [split $database "\n"]
	
	foreach line $data {
	
	set user_read [lindex [split $line] 1]
	set chan_read [lindex [split $line] 0]
	
	if {[string match -nocase $username $user_read] && [string match -nocase $chans $chan_read]} {
	
	set protected($username) 1
	
	}
}

if {![info exists protected($username)]} {

	lappend usernames [join $username ", "]
	user:save $usernames $chans
	
if {$userc(method) == "1"} {

putserv "PRIVMSG X :suspend $chans $username $userc(sdays) $userc(slevel)"
											
						}
					} 
				}
			}
		}
	}
	
	if {[info exists usernames]} {
	
	set nr_username [llength $usernames]
	
	puthelp "PRIVMSG $chans :ALERT ! Found ($nr_username) users that are Online but not on chan. These are : $usernames"
	
	}
	
}


proc filter {str} {
  regsub -all -- {\003([0-9]{1,2}(,[0-9]{1,2})?)?|\017|\037|\002|\026|\006|\007} $str "" str
  return $str
}

proc user:save {userlist chan} {
	global user_file
	set userlist [join $userlist]
	set time [unixtime]

foreach user $userlist {
	
	set file [open $user_file "r"]
	set database [read -nonewline $file]
	close $file
	set data [split $database "\n"]

foreach line $data {
	
	set read_chan [lindex [split $line] 0]
	set read_username [lindex [split $line] 1]

if {[string match -nocase $chan $read_chan] && [string match -nocase $user $read_username]} {

set found_user($user) 1

	}
}

if {![info exists found_user($user)]} {

set file [open $user_file a]
puts $file "$chan $user $time"
close $file

		}
	}
}		

proc usercheck:cmd {nick host hand chan arg} {
	global user_file excepts_file
	
	set option [lindex [split $arg] 0]
	set option_2 [lindex [split $arg] 1]
	set user_add [lindex [split $arg] 2]
	
if {$option == ""} {

	puthelp "NOTICE $nick :Use !usercheck -list | -clear | -except add <user> / del <user> / list"

	return 0
	
}
	
	switch -exact -- [string tolower $option] {
	
	
	-except {
	
if {$option_2 == ""} {
	
	puthelp "NOTICE $nick :Use !usercheck -except add <user> / del <user> / list"
	
	return 0
	
	}
	
	switch -exact -- [string tolower $option_2] {
	
	add {
	
if {$user_add == ""} {
	
	puthelp "NOTICE $nick :Use !usercheck -execept add <user>"
	
	return 0
	
	}
	
	set file [open $excepts_file "r"]
	set database [read -nonewline $file]
	close $file
	set data [split $database "\n"]
	
foreach line $data {
	
	set user_read [lindex [split $line] 1]
	set chan_read [lindex [split $line] 0]
	
if {[string match -nocase $user_add $user_read] && [string match -nocase $chan $chan_read]} {
	
	puthelp "NOTICE $nick :Error. $user_read is already in my exception list."
	
	return 0
	
	}
}
	
	set file [open $excepts_file a]
	puts $file "$chan $user_add"
	close $file
	
	puthelp "NOTICE $nick :Added as exception user : $user_add"
	
}
	
	list {
	
	set counter 0
	set file [open $excepts_file "r"]
	set database [read -nonewline $file]
	close $file
	set data [split $database "\n"]
	
	puthelp "NOTICE $nick :Exception list :"
	
foreach line $data {
	
	set user_read [lindex [split $line] 1]
	set chan_read [lindex [split $line] 0]
	
if {[string match -nocase $chan $chan_read]} {
	
	set found_entry 1
	set counter [expr $counter + 1]
	
	puthelp "NOTICE $nick :$counter) $user_read"
	
	}
}
	
	
	if {![info exists found_entry]} {
	
	puthelp "NOTICE $nick :NONE"
	
	}	
}
	
	del {
	
if {$user_add == ""} {
	
	puthelp "NOTICE $nick :Use !usercheck -except del <user>"
	
	return 0
	
	}
	
	
	set counter 0
	set file [open $excepts_file "r"]
	set database [read -nonewline $file]
	close $file
	set data [split $database "\n"]
	
foreach line $data {
	set counter [expr $counter + 1]
	set user_read [lindex [split $line] 1]
	set chan_read [lindex [split $line] 0]
	
if {[string match -nocase $user_add $user_read] && [string match -nocase $chan $chan_read]} {
	
	set found_entry 1
	
	if {$line != ""} {
	set counter [expr $counter - 1]
	set delete [lreplace $data $counter $counter]
	set files [open $excepts_file "w"]
	puts $files [join $delete "\n"]
	close $files
	
		}
	}
}
	
	set file [open $excepts_file "r"]
	set data [read -nonewline $file]
	close $file
	
if {$data == ""} {
	set files [open $excepts_file "w"]
	close $files
}

if {![info exists found_entry]} {

	puthelp "NOTICE $nick :Error. $user_add isn't in my exception list."
	
} else {

	puthelp "NOTICE $nick :Erased $user_add from my exception list"

			}
		}	
	}
}
		
	-clear {
	
	set count_check 0
	set line_check 0
	
	set file [open $user_file "r"]
	set database [read -nonewline $file]
	close $file
	set data [split $database "\n"]
	
foreach line $data {
	set read_chan [lindex [split $line] 0]
if {[string match -nocase $chan $read_chan]} {
	set count_check [expr $count_check + 1]

	lappend user_delete $read_chan

}
}

if {[info exists user_delete]} {

	info:remove $user_delete

}	
	puthelp "NOTICE $nick :Cleared ($count_check) entrys."
}
	
	
	-list {
	
	puthelp "NOTICE $nick :UserCheck List is :"
	
	set count_check 0
	set file [open $user_file "r"]
	set database [read -nonewline $file]
	close $file
	set data [split $database "\n"]
if {$data == ""} {

	puthelp "NOTICE $nick :NONE"
	return 0
	
}

foreach line $data {
set read_chan [lindex [split $line] 0]
if {[string match -nocase $chan $read_chan]} {

set count_check [expr $count_check + 1]

}
}

putserv "NOTICE $nick :Found 1 $count_check  users"

foreach line $data {
	
	set read_chan [lindex [split $line] 0]
	set read_username [lindex [split $line] 1]
	set read_time [lindex [split $line] 2]

if {[string match -nocase $chan $read_chan]} {
	
	
	set found_username 1
	
	puthelp "NOTICE $nick :User : 1 $read_username | Spotted time : 1[ctime $read_time]"

	
}
}

if {![info exists found_username]} {

	puthelp "NOTICE $nick :NONE"

			}
		}
	}
}

proc user:expire:check {chan} {
	global user_file userc
	
	putlog "Checking entrys on $chan.."
	set file [open $user_file "r"]
	set database [read -nonewline $file]
	close $file
	set data [split $database "\n"]
foreach line $data {
	if {$line != ""} {
	set channel [lindex [split $line] 0]
if {[string match -nocase $chan $channel]} {
	set time_show [lindex [split $line] 2]
	set user_show [lindex [split $line] 1]
	if {[expr [unixtime] - $time_show] > [expr $userc(days) * 2880]} {
lappend user_list $user_show
			}
		}	
	}
}

if {[info exists user_list]} {
	putlog "Found [llength $user_list] expired entryes on $chan"
	user:remove $user_list $chan
	}
}


proc user:remove {userlist chan} {
	global user_file
	set list [join $userlist]
foreach tm $list {
if {$tm != ""} {
	puthelp "PRIVMSG X :remuser $chan $tm"
	set file [open $user_file "r"]
	set database [read -nonewline $file]
	close $file
	set data [split $database "\n"]
	set i [lsearch -glob [string tolower $data] [string tolower "$chan $tm *"]]
if {$i > -1} {
	set line [lindex $data $i]
	set delete [lreplace $data $i $i]
	set file [open $user_file "w"] 
	puts $file [join $delete "\n"]
	close $file	
	
			}
		}
	}
}


proc entry:remove {user chan} {
	global user_file

	set file [open $user_file "r"]
	set database [read -nonewline $file]
	close $file
	set data [split $database "\n"]
	set i [lsearch -glob [string tolower $data] [string tolower "$chan $user *"]]
if {$i > -1} {
	set line [lindex $data $i]
	set delete [lreplace $data $i $i]
	set file [open $user_file "w"] 
	puts $file [join $delete "\n"]
	close $file	
	}
}


proc info:remove {userlist} {
	global user_file

	
	set list [join $userlist]
foreach tm $list {
if {$tm != ""} {
	set file [open $user_file "r"]
	set database [read -nonewline $file]
	close $file
	set data [split $database "\n"]
	set i [lsearch -glob $data "$tm *"]
if {$i > -1} {
	set line [lindex $data $i]
	set delete [lreplace $data $i $i]
	set file [open $user_file "w"] 
	puts $file [join $delete "\n"]
	close $file	
	
			}
		}
	}
}


proc usercheck:join {nick host hand chan} {
if {[channel get $chan usercheck]} {
if {[isbotnick $nick]} { return 0 }
if {[onchan $nick $chan]} {

set ::usercheck_channel $chan
set ::usercheck_nick $nick

utimer 5 [list putserv "WHOIS $nick $nick"]

bind RAW - 330 usercheck:logged

		}
	}
}

proc usercheck:logged {from keyword arguments} {
	global user_file
	set nick $::usercheck_nick
	set chan $::usercheck_channel
	set found_user [lindex $arguments 2]
	
if {[channel get $chan usercheck]} {

	set file [open $user_file "r"]
	set database [read -nonewline $file]
	close $file
	set data [split $database "\n"]
	
	foreach line $data {
	
	set chan_show [lindex [split $line] 0]
	set time_show [lindex [split $line] 2]
	set user_show [lindex [split $line] 1]
	
if {[string match -nocase $chan $chan_show] && [string match -nocase $found_user $user_show]} {
	
		puthelp "PRIVMSG $nick :- ALERT - You have been spotted outside of chan (having access on 4$chan) on date 4 [ctime $time_show]"		
	
		entry:remove $found_user $chan
	
			}
		}
	}
}


putlog "UserCheck 1.1b by BLaCkShaDoW Loaded"

